var _excluded = ["separator", "caption", "min", "max", "type", "value", "StartComboProps", "EndComboProps", "visible", "onVisibleChange", "onChange", "onError"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useState, useEffect } from 'react';
import Modal from "./../../Modal";
import InputDate from "./../Combo";
import locale from "./../../locale";
import DateModalUtils from "./../Modal/Utils"; // 自定义时间

var RangeModal = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$separator = _ref.separator,
      separator = _ref$separator === void 0 ? '' : _ref$separator,
      caption = _ref.caption,
      min = _ref.min,
      max = _ref.max,
      type = _ref.type,
      value = _ref.value,
      _ref$StartComboProps = _ref.StartComboProps,
      StartComboProps = _ref$StartComboProps === void 0 ? {} : _ref$StartComboProps,
      _ref$EndComboProps = _ref.EndComboProps,
      EndComboProps = _ref$EndComboProps === void 0 ? {} : _ref$EndComboProps,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      onChange = _ref.onChange,
      onError = _ref.onError,
      props = _objectWithoutProperties(_ref, _excluded);

  // 标题与日期范围
  var key = null;
  var range = null;

  if (Object.prototype.toString.call(visible) === '[object Object]') {
    var items = Object.entries(visible)[0];

    if (items && items.length === 2) {
      key = items[0];
      range = items[1];
    }
  } // 自定义日期数据


  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      startDate = _useState2[0],
      setStartDate = _useState2[1];

  var _useState3 = useState(null),
      _useState4 = _slicedToArray(_useState3, 2),
      endDate = _useState4[0],
      setEndDate = _useState4[1];

  useEffect(function () {
    if (visible) {
      initDate();
    }
  }, [JSON.stringify(visible)]); // eslint-disable-line
  // 初始化数据

  function initDate() {
    if (Array.isArray(value) && value.length) {
      setStartDate(value[0]);
      setEndDate(value[1] || null);
      return;
    }

    if (Array.isArray(range) && range.length) {
      setStartDate(range[0]);
      setEndDate(range[1] || null);
    }
  } // 点击自定义取消


  function handleCancel() {
    if (onVisibleChange) onVisibleChange(false);
    initDate();
  } // 点击自定义确定


  function handleSubmit() {
    if (onChange) {
      onChange([startDate, endDate]);
    }
  } // 修改自定义开始时间


  function handleStartDate(value) {
    var newValue = DateModalUtils.validateDate(value, {
      type: type,
      min: min,
      max: max,
      onError: onError
    });
    if (newValue === false) return;
    setStartDate(newValue);
  } // 修改自定义结束时间


  function handleEndDate(value) {
    var newValue = DateModalUtils.validateDate(value, {
      type: type,
      min: min,
      max: max,
      onError: onError
    });
    if (newValue === false) return;
    setEndDate(newValue);
  }

  return /*#__PURE__*/React.createElement(Modal, _extends({
    ref: ref,
    visible: visible,
    captionProps: {
      caption: key || caption || ''
    },
    submitProps: {
      onClick: handleSubmit
    },
    cancelProps: {
      onClick: handleCancel
    }
  }, props), /*#__PURE__*/React.createElement(InputDate, _extends({
    type: type || 'date',
    max: endDate,
    value: startDate,
    onChange: handleStartDate,
    placeholder: locale('请选择'),
    className: "datepicker-modal-combo",
    ModalProps: {
      maskProps: {
        style: {
          zIndex: '11'
        }
      }
    }
  }, StartComboProps || {})), /*#__PURE__*/React.createElement(InputDate, _extends({
    type: type || 'date',
    min: startDate,
    value: endDate,
    onChange: handleEndDate,
    placeholder: locale('请选择'),
    className: "datepicker-modal-combo",
    ModalProps: {
      maskProps: {
        style: {
          zIndex: '11'
        }
      }
    }
  }, EndComboProps || {})));
});
export default RangeModal;