var _excluded = ["instance", "value", "onChange"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import Loading from "./../../../../Loading";
import Toast from "./../../../../Toast";

function Location(_ref) {
  var instance = _ref.instance,
      value = _ref.value,
      _onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, _excluded);

  function handleLocation() {
    if (!instance.current) return;
    Loading.show();
    instance.current.getLocation({
      onChange: function onChange(value) {
        Loading.hide();
        if (!value) return; // 视图更新

        instance.current.centerToPoint([value.longitude, value.latitude]);
        if (_onChange) _onChange(value);
      },
      onError: function onError(err) {
        Loading.hide();
        Toast.show(err.errMsg, {
          maskClickable: true
        });
      }
    });
  }

  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "map-location".concat(props.className ? ' ' + props.className : ''),
    onClick: handleLocation
  }), /*#__PURE__*/React.createElement("div", {
    className: "map-location-icon"
  }));
}

export default Location;