var _excluded = ["animation", "titlebarVisible", "children"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import Device from "./../Device";
import Header from "./../Header";
import Titlebar from "./../Titlebar";
var Page = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var animation = _ref.animation,
      _ref$titlebarVisible = _ref.titlebarVisible,
      titlebarVisible = _ref$titlebarVisible === void 0 ? 'auto' : _ref$titlebarVisible,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  var rootRef = useRef(null); // 节点

  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 支持根据标题自动渲染Titlebar

  var titleText = Device.getUrlParameter('showTitlebar');

  if (titlebarVisible === 'auto') {
    // URL中包含titlebar参数显示
    titlebarVisible = window.location.href.indexOf('?showTitlebar=') !== -1 || window.location.href.indexOf('&showTitlebar=') !== -1; // 全局配置显示

    if (window.__SeedsUI_config__ && Object.prototype.toString.call(window.__SeedsUI_config__) === '[object Object]') {
      var _window$__SeedsUI_con, _window$__SeedsUI_con2;

      if ((_window$__SeedsUI_con = window.__SeedsUI_config__) !== null && _window$__SeedsUI_con !== void 0 && (_window$__SeedsUI_con2 = _window$__SeedsUI_con.Titlebar) !== null && _window$__SeedsUI_con2 !== void 0 && _window$__SeedsUI_con2.titlebarVisible) {
        titlebarVisible = true;
      }
    }
  }

  return /*#__PURE__*/React.createElement("section", _extends({
    ref: rootRef
  }, props, {
    className: 'page' + (props.className ? ' ' + props.className : ''),
    "data-animation": animation
  }), titlebarVisible ? /*#__PURE__*/React.createElement(Header, null, /*#__PURE__*/React.createElement(Titlebar, {
    caption: decodeURIComponent(decodeURIComponent(titleText || ''))
  })) : null, children);
});
export default Page;