var _excluded = ["animation", "style", "getChildrenDOM", "children", "visible", "onVisibleChange"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useRef, useEffect, useImperativeHandle, useState } from 'react';
import Popup from "./Popup";
import Utils from "./Utils";
var Tooltip = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'slideDownLeft' : _ref$animation,
      style = _ref.style,
      getChildrenDOM = _ref.getChildrenDOM,
      children = _ref.children,
      visible = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      props = _objectWithoutProperties(_ref, _excluded);

  var rootRef = useRef(null);
  var childrenRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  }); // 非受控显隐

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      autoVisible = _useState2[0],
      setAutoVisible = _useState2[1]; // 受控显隐时, 需要更新容器位置


  useEffect(function () {
    var childrenDOM = childrenRef.current;

    if (typeof getChildrenDOM === 'function') {
      var _childrenDOM;

      childrenDOM = getChildrenDOM();

      if (typeof ((_childrenDOM = childrenDOM) === null || _childrenDOM === void 0 ? void 0 : _childrenDOM.getRootDOM) === 'function') {
        childrenDOM = childrenDOM.getRootDOM();
      }
    }

    if (visible && childrenDOM) {
      Utils.updateContainerPosition({
        source: rootRef.current,
        target: childrenDOM,
        style: style,
        animation: animation
      });
    }
  }, [visible]); // eslint-disable-line
  // 非受控显隐, 为子元素增加点击事件显隐

  var newChildren = React.Children.toArray(children);

  if (newChildren.length === 1) {
    newChildren = /*#__PURE__*/React.cloneElement(children, {
      ref: childrenRef,
      onClick: function onClick(e) {
        Utils.updateContainerPosition({
          source: rootRef.current,
          target: e.currentTarget,
          style: style,
          animation: animation
        });

        if (typeof visible !== 'boolean') {
          setAutoVisible(!autoVisible);
        }
      }
    });
  } else {
    newChildren = children;
  } // 点击遮罩隐藏


  function handleVisibleChange(newVisible) {
    if (typeof visible !== 'boolean') {
      setAutoVisible(newVisible);
    }

    if (typeof onVisibleChange === 'function') {
      onVisibleChange(newVisible);
    }
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Popup, _extends({
    ref: rootRef,
    animation: animation,
    style: style,
    visible: typeof visible === 'boolean' ? visible : autoVisible,
    onVisibleChange: handleVisibleChange
  }, props)), newChildren);
});
export default Tooltip;