var _excluded = ["onClick", "showPlay", "preview", "routePath", "videoFullProps"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, Fragment, useState } from 'react';
import Bridge from "./../Bridge";
import Photos from "./../Photos";
import VideoFull from "./../VideoFull"; // import Camera from './../Camera'

import locale from "./../locale"; // 预览项

var previewIndex = null; // 视频栅格

var Videos = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var onClick = _ref.onClick,
      _ref$showPlay = _ref.showPlay,
      showPlay = _ref$showPlay === void 0 ? false : _ref$showPlay,
      _ref$preview = _ref.preview,
      preview = _ref$preview === void 0 ? true : _ref$preview,
      _ref$routePath = _ref.routePath,
      routePath = _ref$routePath === void 0 ? 'componentPage=1' : _ref$routePath,
      _ref$videoFullProps = _ref.videoFullProps,
      videoFullProps = _ref$videoFullProps === void 0 ? {} : _ref$videoFullProps,
      others = _objectWithoutProperties(_ref, _excluded);

  // 预览项
  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      previewItem = _useState2[0],
      setPreivewItem = _useState2[1]; // 返回


  function handlePop() {
    handleClosePreview(); // 返回后允许关闭webview

    window.onHistoryBack = null;
    window.removeEventListener('popstate', handlePop, false);
  } // 点击预览


  function handleClick(e, src, options, index) {
    var item = options[0]; // 点击回调

    if (onClick) {
      onClick(e, src, options, index);
    }

    if (!preview) return;

    if (!item.src) {
      Bridge.showToast(locale('没有参数src', 'no_param_src'), {
        mask: false
      });
    } // 增加历史记录


    if (routePath) {
      // 阻止关闭webview
      window.onHistoryBack = function () {}; // 路径增加routePath


      var path = window.location.href;
      path += "".concat(path.indexOf('?') === -1 ? '?' : '&').concat(routePath); // 增加历史记录

      window.history.pushState({
        href: path
      }, document.title, path);
      window.removeEventListener('popstate', handlePop, false);
      window.addEventListener('popstate', handlePop, false);
    } // 预览回调


    if (typeof preview === 'function') {
      previewIndex = index;
      e.visible = true;
      preview(e, src, options, index);
    } // 客户端预览视频有问题, 所以使用h5预览


    previewItem = item;
    setPreivewItem(item);
  } // 关闭h5预览


  function handleClosePreview(e) {
    // 已经返回, 路由却没变
    if (window.location.href.indexOf(routePath) !== -1) {
      window.history.go(-1);
      return;
    } // 预览回调


    if (typeof preview === 'function') {
      e.visible = false;
      preview(e, previewItem.src, [previewItem], previewIndex);
    } // 隐藏预览


    previewItem = null;
    setPreivewItem(null);
  }
  /*
  // h5录相
  const [showRecord, setShowRecord] = useState(false);
  // 录制视频
  function choose (e) {
    if (Bridge.platform !== 'wq') {
      setShowRecord(true);
      return;
    }
    if (onChoose) {
      onChoose(e);
    }
  }
  // h5录相
  function record (e) {
    if (onChoose) {
      onChoose(e);
    }
  }
  */


  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(Photos, _extends({
    ref: ref
  }, others, {
    onClick: handleClick // onChoose={choose}
    ,
    type: "video",
    preview: false,
    children: showPlay ?
    /*#__PURE__*/
    // 视频播放图标
    React.createElement("div", {
      className: "photos-item-video"
    }, /*#__PURE__*/React.createElement("div", {
      className: "photos-item-video-icon"
    })) : null
  })), previewItem && /*#__PURE__*/React.createElement(VideoFull, _extends({
    portal: document.getElementById('root') || document.body,
    poster: previewItem.thumb,
    src: previewItem.src,
    autoPlay: true,
    bar: /*#__PURE__*/React.createElement("div", {
      className: "videofull-close",
      onClick: handleClosePreview
    })
  }, videoFullProps)));
});
export default Videos;